﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DrawLineDemoCSharp
{
    public partial class fMain : Form
    {
        Boolean drawLineStart, drawingLine;
        int x1, y1, x2, y2;

        public fMain()
        {
            InitializeComponent();
        }

        private void fMain_Load(object sender, EventArgs e)
        {
            axImageBox1.NewImage(360, 280);

            //This PenMode means that a line can be erased by re-drawing on top of it
            axImageBox1.PenMode = csXImageTrial.TxPenMode.pmNotXor;
        }

        private void cmdClear_Click(object sender, EventArgs e)
        {
            axImageBox1.NewImage(360, 280);
        }

        private void cmdDrawLine_Click(object sender, EventArgs e)
        {
            //This flag indicates to the OnMouseDownEvent that drawing will start
            drawLineStart = true;

            //Disable this button
            cmdDrawLine.Enabled = false;
        }

        private void fMain_MouseMove(object sender, MouseEventArgs e)
        {
            fMain.ActiveForm.Cursor = Cursors.Default;
        }

        private void axImageBox1_OnMouseDown(object sender, AxcsXImageTrial.IImageBoxEvents_OnMouseDownEvent e)
        {
            if (drawLineStart)
            {
                //Record the start coordinates of the line
                x1 = e.x;
                y1 = e.y;
                x2 = e.x;
                y2 = e.y;

                //Reset the start flag
                drawLineStart = false;

                //This flag indicates to the OnMouseMove event that drawing is in progress
                drawingLine = true;
            }
        }

        private void axImageBox1_OnMouseMove(object sender, AxcsXImageTrial.IImageBoxEvents_OnMouseMoveEvent e)
        {
            if (drawingLine || drawLineStart)
                //Use the crosshair cursor when drawing
                fMain.ActiveForm.Cursor = Cursors.Cross;
            if (drawingLine)
            {
                //Erase the previous line
                //(note the PenMode setting in fMain_Load)
                axImageBox1.DrawLine(x1, y1, x2, y2);

                //Set the new line end coordinates and draw a new line
                x2 = e.x;
                y2 = e.y;
                axImageBox1.DrawLine(x1, y1, x2, y2);
            }
        }

        private void axImageBox1_OnMouseUp(object sender, AxcsXImageTrial.IImageBoxEvents_OnMouseUpEvent e)
        {
            //Stop drawing and re-enable the Draw button
            drawingLine = false;
            cmdDrawLine.Enabled = true;
            fMain.ActiveForm.Cursor = Cursors.Default;
        }


    }
}
